diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-test-secondary-cell-selection.h ns-3.36/src/lte/test/lte-test-secondary-cell-selection.h
--- ns-3.35/src/lte/test/lte-test-secondary-cell-selection.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/lte/test/lte-test-secondary-cell-selection.h	2022-04-30 18:23:58.062734600 -0700
@@ -0,0 +1,118 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Alexander Krotov
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alexander Krotov <krotov@iitp.ru>
+ *
+ */
+
+#ifndef LTE_TEST_SECONDARY_CELL_SELECTION_H
+#define LTE_TEST_SECONDARY_CELL_SELECTION_H
+
+#include <ns3/test.h>
+#include <ns3/nstime.h>
+#include <ns3/node-container.h>
+#include <ns3/vector.h>
+#include <ns3/lte-ue-rrc.h>
+#include <vector>
+
+using namespace ns3;
+
+/**
+ * \ingroup lte-test
+ *
+ * \brief Test suite for executing the secondary cell selection test cases.
+ *
+ * Checks that if multiple component carriers are defined for an eNB, that
+ * UEs can connect to each of these component carriers, not just the primary
+ *
+ * \sa ns3::LteSecondaryCellSelectionTestCase
+ */
+class LteSecondaryCellSelectionTestSuite : public TestSuite
+{
+public:
+  LteSecondaryCellSelectionTestSuite ();
+};
+
+
+/**
+ * \ingroup lte-test
+ *
+ * \brief Testing the initial cell selection procedure by UE at IDLE state in
+ *        the beginning of simulation with multiple component carriers.
+ */
+class LteSecondaryCellSelectionTestCase : public TestCase
+{
+public:
+  /**
+   * \brief Creates an instance of the initial cell selection test case.
+   * \param name name of this test
+   * \param isIdealRrc if true, simulation uses Ideal RRC protocol, otherwise
+   *                   simulation uses Real RRC protocol
+   * \param rngRun the number of run to be used by the random number generator
+   * \param numberOfComponentCarriers number of component carriers
+   */
+  LteSecondaryCellSelectionTestCase (std::string name, bool isIdealRrc, uint64_t rngRun, uint8_t numberOfComponentCarriers);
+
+  virtual ~LteSecondaryCellSelectionTestCase ();
+
+private:
+  /**
+   * \brief Setup the simulation according to the configuration set by the
+   *        class constructor, run it, and verify the result.
+   */
+  virtual void DoRun ();
+
+  /**
+   * \brief State transition callback function
+   * \param context the context string
+   * \param imsi the IMSI
+   * \param cellId the cell ID
+   * \param rnti the RNTI
+   * \param oldState the old state
+   * \param newState the new state
+   */
+  void StateTransitionCallback (std::string context, uint64_t imsi,
+                                uint16_t cellId, uint16_t rnti,
+                                LteUeRrc::State oldState, LteUeRrc::State newState);
+  /**
+   * \brief Initial cell selection end ok callback function
+   * \param context the context string
+   * \param imsi the IMSI
+   * \param cellId the cell ID
+   */
+  void InitialSecondaryCellSelectionEndOkCallback (std::string context, uint64_t imsi,
+                                          uint16_t cellId);
+  /**
+   * \brief Connection established callback function
+   * \param context the context string
+   * \param imsi the IMSI
+   * \param cellId the cell ID
+   * \param rnti the RNTI
+   */
+  void ConnectionEstablishedCallback (std::string context, uint64_t imsi,
+                                      uint16_t cellId, uint16_t rnti);
+
+  bool m_isIdealRrc; ///< whether the LTE is configured to use ideal RRC
+  uint64_t m_rngRun; ///< rng run
+  uint8_t m_numberOfComponentCarriers; ///< number of component carriers
+
+  /// The current UE RRC state.
+  std::map<uint64_t, LteUeRrc::State> m_lastState;
+
+}; // end of class LteSecondaryCellSelectionTestCase
+
+#endif /* LTE_TEST_SECONDARY_CELL_SELECTION_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-test-ue-measurements.cc ns-3.36/src/lte/test/lte-test-ue-measurements.cc
--- ns-3.35/src/lte/test/lte-test-ue-measurements.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/lte-test-ue-measurements.cc	2022-04-30 18:23:58.062734600 -0700
@@ -249,13 +249,13 @@
         {
           NS_LOG_DEBUG (this << "Serving Cell: received IMSI " << imsi << " CellId " << cellId << " RNTI " << rnti
                              << " thr " << (uint16_t) EutranMeasurementMapping::Dbm2RsrpRange (m_rsrpDbmUeServingCell)
-                             << " RSRP " << (uint16_t) meas.measResults.rsrpResult
-                             << " RSRQ " << (uint16_t)meas.measResults.rsrqResult
+                             << " RSRP " << (uint16_t) meas.measResults.measResultPCell.rsrpResult
+                             << " RSRQ " << (uint16_t)meas.measResults.measResultPCell.rsrqResult
                              << " thr " << (uint16_t) EutranMeasurementMapping::Db2RsrqRange (m_rsrqDbUeServingCell));
-          NS_TEST_ASSERT_MSG_EQ (meas.measResults.rsrpResult,
+          NS_TEST_ASSERT_MSG_EQ (meas.measResults.measResultPCell.rsrpResult,
                                  EutranMeasurementMapping::Dbm2RsrpRange (m_rsrpDbmUeServingCell),
                                  "Wrong RSRP ");
-          NS_TEST_ASSERT_MSG_EQ (meas.measResults.rsrqResult,
+          NS_TEST_ASSERT_MSG_EQ (meas.measResults.measResultPCell.rsrqResult,
                                  EutranMeasurementMapping::Db2RsrqRange (m_rsrqDbUeServingCell),
                                  "Wrong RSRQ ");
         }
@@ -263,13 +263,13 @@
         {
           NS_LOG_DEBUG (this << "Neighbor cell: received IMSI " << imsi << " CellId " << cellId << " RNTI " << rnti
                              << " thr " << (uint16_t) EutranMeasurementMapping::Dbm2RsrpRange (m_rsrpDbmUeNeighborCell)
-                             << " RSRP " << (uint16_t) meas.measResults.rsrpResult
-                             << " RSRQ " << (uint16_t)meas.measResults.rsrqResult
+                             << " RSRP " << (uint16_t) meas.measResults.measResultPCell.rsrpResult
+                             << " RSRQ " << (uint16_t)meas.measResults.measResultPCell.rsrqResult
                              << " thr " << (uint16_t) EutranMeasurementMapping::Db2RsrqRange (m_rsrqDbUeNeighborCell));
-          NS_TEST_ASSERT_MSG_EQ (meas.measResults.rsrpResult,
+          NS_TEST_ASSERT_MSG_EQ (meas.measResults.measResultPCell.rsrpResult,
                                  EutranMeasurementMapping::Dbm2RsrpRange (m_rsrpDbmUeNeighborCell),
                                  "Wrong RSRP ");
-          NS_TEST_ASSERT_MSG_EQ (meas.measResults.rsrqResult,
+          NS_TEST_ASSERT_MSG_EQ (meas.measResults.measResultPCell.rsrqResult,
                                  EutranMeasurementMapping::Db2RsrqRange (m_rsrqDbUeNeighborCell),
                                  "Wrong RSRQ ");
         }
@@ -598,7 +598,7 @@
 
   // Setup UE measurement configuration
   Ptr<LteEnbRrc> enbRrc = enbDevs.Get (0)->GetObject<LteEnbNetDevice> ()->GetRrc ();
-  m_expectedMeasId = enbRrc->AddUeMeasReportConfig (m_config);
+  m_expectedMeasId = enbRrc->AddUeMeasReportConfig (m_config).at (0);
 
   // Attach UE to eNodeB
   lteHelper->Attach (ueDevs.Get (0), enbDevs.Get (0));
@@ -674,10 +674,10 @@
     {
       // verifying the report completeness
       LteRrcSap::MeasResults measResults = report.measResults;
-      NS_LOG_DEBUG (this << " rsrp=" << (uint16_t) measResults.rsrpResult
-                         << " (" << EutranMeasurementMapping::RsrpRange2Dbm (measResults.rsrpResult) << " dBm)"
-                         << " rsrq=" << (uint16_t) measResults.rsrqResult
-                         << " (" << EutranMeasurementMapping::RsrqRange2Db (measResults.rsrqResult) << " dB)");
+      NS_LOG_DEBUG (this << " rsrp=" << (uint16_t) measResults.measResultPCell.rsrpResult
+                         << " (" << EutranMeasurementMapping::RsrpRange2Dbm (measResults.measResultPCell.rsrpResult) << " dBm)"
+                         << " rsrq=" << (uint16_t) measResults.measResultPCell.rsrqResult
+                         << " (" << EutranMeasurementMapping::RsrqRange2Db (measResults.measResultPCell.rsrqResult) << " dB)");
       NS_TEST_ASSERT_MSG_EQ (measResults.haveMeasResultNeighCells, false,
                              "Report should not have neighboring cells information");
       NS_TEST_ASSERT_MSG_EQ (measResults.measResultListEutra.size (), 0,
@@ -697,7 +697,7 @@
           uint64_t timeExpectedMs = m_itExpectedTime->GetMilliSeconds ();
           m_itExpectedTime++;
 
-          uint16_t observedRsrp = measResults.rsrpResult;
+          uint16_t observedRsrp = measResults.measResultPCell.rsrpResult;
           uint16_t referenceRsrp = *m_itExpectedRsrp;
           m_itExpectedRsrp++;
 
@@ -1184,7 +1184,7 @@
 
   // Setup UE measurement configuration in serving cell
   Ptr<LteEnbRrc> enbRrc1 = enbDevs.Get (0)->GetObject<LteEnbNetDevice> ()->GetRrc ();
-  m_expectedMeasId = enbRrc1->AddUeMeasReportConfig (m_config);
+  m_expectedMeasId = enbRrc1->AddUeMeasReportConfig (m_config).at (0);
 
   // Disable handover in neighbour cell
   Ptr<LteEnbRrc> enbRrc2 = enbDevs.Get (1)->GetObject<LteEnbNetDevice> ()->GetRrc ();
@@ -1265,10 +1265,10 @@
       // verifying the report completeness
       LteRrcSap::MeasResults measResults = report.measResults;
       NS_LOG_DEBUG (this << " Serving cellId=" << cellId
-                         << " rsrp=" << (uint16_t) measResults.rsrpResult
-                         << " (" << EutranMeasurementMapping::RsrpRange2Dbm (measResults.rsrpResult) << " dBm)"
-                         << " rsrq=" << (uint16_t) measResults.rsrqResult
-                         << " (" << EutranMeasurementMapping::RsrqRange2Db (measResults.rsrqResult) << " dB)");
+                         << " rsrp=" << (uint16_t) measResults.measResultPCell.rsrpResult
+                         << " (" << EutranMeasurementMapping::RsrpRange2Dbm (measResults.measResultPCell.rsrpResult) << " dBm)"
+                         << " rsrq=" << (uint16_t) measResults.measResultPCell.rsrqResult
+                         << " (" << EutranMeasurementMapping::RsrqRange2Db (measResults.measResultPCell.rsrqResult) << " dB)");
 
       // verifying reported best cells
       if (measResults.measResultListEutra.size () == 0)
@@ -1312,7 +1312,7 @@
           uint64_t timeExpectedMs = m_itExpectedTime->GetMilliSeconds ();
           m_itExpectedTime++;
 
-          uint16_t observedRsrp = measResults.rsrpResult;
+          uint16_t observedRsrp = measResults.measResultPCell.rsrpResult;
           uint16_t referenceRsrp = *m_itExpectedRsrp;
           m_itExpectedRsrp++;
 
@@ -1478,7 +1478,7 @@
 
   // Setup UE measurement configuration in serving cell
   Ptr<LteEnbRrc> enbRrc1 = enbDevs.Get (0)->GetObject<LteEnbNetDevice> ()->GetRrc ();
-  m_expectedMeasId = enbRrc1->AddUeMeasReportConfig (m_config);
+  m_expectedMeasId = enbRrc1->AddUeMeasReportConfig (m_config).at (0);
 
   // Disable handover in neighbour cells
   Ptr<LteEnbRrc> enbRrc2 = enbDevs.Get (1)->GetObject<LteEnbNetDevice> ()->GetRrc ();
@@ -1538,10 +1538,10 @@
       // verifying the report completeness
       LteRrcSap::MeasResults measResults = report.measResults;
       NS_LOG_DEBUG (this << " Serving cellId=" << cellId
-                         << " rsrp=" << (uint16_t) measResults.rsrpResult
-                         << " (" << EutranMeasurementMapping::RsrpRange2Dbm (measResults.rsrpResult) << " dBm)"
-                         << " rsrq=" << (uint16_t) measResults.rsrqResult
-                         << " (" << EutranMeasurementMapping::RsrqRange2Db (measResults.rsrqResult) << " dB)");
+                         << " rsrp=" << (uint16_t) measResults.measResultPCell.rsrpResult
+                         << " (" << EutranMeasurementMapping::RsrpRange2Dbm (measResults.measResultPCell.rsrpResult) << " dBm)"
+                         << " rsrq=" << (uint16_t) measResults.measResultPCell.rsrqResult
+                         << " (" << EutranMeasurementMapping::RsrqRange2Db (measResults.measResultPCell.rsrqResult) << " dB)");
 
       // verifying reported best cells
       if (measResults.measResultListEutra.size () == 0)
@@ -2015,14 +2015,14 @@
   for (itReportConfig = m_sourceConfigList.begin ();
        itReportConfig != m_sourceConfigList.end (); itReportConfig++)
     {
-      measId = enbRrc1->AddUeMeasReportConfig (*itReportConfig);
+      measId = enbRrc1->AddUeMeasReportConfig (*itReportConfig).at (0);
       m_expectedSourceCellMeasId.insert (measId);
     }
 
   for (itReportConfig = m_targetConfigList.begin ();
        itReportConfig != m_targetConfigList.end (); itReportConfig++)
     {
-      measId = enbRrc2->AddUeMeasReportConfig (*itReportConfig);
+      measId = enbRrc2->AddUeMeasReportConfig (*itReportConfig).at (0);
       m_expectedTargetCellMeasId.insert (measId);
     }
 
@@ -2107,10 +2107,10 @@
       // verifying the report completeness
       LteRrcSap::MeasResults measResults = report.measResults;
       NS_LOG_DEBUG (this << " Serving cellId=" << cellId
-                         << " rsrp=" << (uint16_t) measResults.rsrpResult
-                         << " (" << EutranMeasurementMapping::RsrpRange2Dbm (measResults.rsrpResult) << " dBm)"
-                         << " rsrq=" << (uint16_t) measResults.rsrqResult
-                         << " (" << EutranMeasurementMapping::RsrqRange2Db (measResults.rsrqResult) << " dB)");
+                         << " rsrp=" << (uint16_t) measResults.measResultPCell.rsrpResult
+                         << " (" << EutranMeasurementMapping::RsrpRange2Dbm (measResults.measResultPCell.rsrpResult) << " dBm)"
+                         << " rsrq=" << (uint16_t) measResults.measResultPCell.rsrqResult
+                         << " (" << EutranMeasurementMapping::RsrqRange2Db (measResults.measResultPCell.rsrqResult) << " dB)");
 
       // verifying reported best cells
       if (measResults.measResultListEutra.size () == 0)
@@ -2155,7 +2155,7 @@
           uint64_t timeExpectedMs = m_itExpectedTime->GetMilliSeconds ();
           m_itExpectedTime++;
 
-          uint16_t observedRsrp = measResults.rsrpResult;
+          uint16_t observedRsrp = measResults.measResultPCell.rsrpResult;
           uint16_t referenceRsrp = *m_itExpectedRsrp;
           m_itExpectedRsrp++;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/test-asn1-encoding.cc ns-3.36/src/lte/test/test-asn1-encoding.cc
--- ns-3.35/src/lte/test/test-asn1-encoding.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/test-asn1-encoding.cc	2022-04-30 18:23:58.062734600 -0700
@@ -1024,8 +1024,8 @@
 
   LteRrcSap::MeasurementReport msg;
   msg.measResults.measId = 5;
-  msg.measResults.rsrpResult = 18;
-  msg.measResults.rsrqResult = 21;
+  msg.measResults.measResultPCell.rsrpResult = 18;
+  msg.measResults.measResultPCell.rsrqResult = 21;
   msg.measResults.haveMeasResultNeighCells = true;
 
   LteRrcSap::MeasResultEutra mResEutra;
@@ -1040,7 +1040,7 @@
   mResEutra.cgiInfo.trackingAreaCode = 5;
   msg.measResults.measResultListEutra.push_back (mResEutra);
 
-  msg.measResults.haveScellsMeas = false;
+  msg.measResults.haveMeasResultServFreqList = false;
 
   MeasurementReportHeader source;
   source.SetMessage (msg);
@@ -1066,8 +1066,8 @@
   LteRrcSap::MeasResults dstMeas = destination.GetMessage ().measResults;
 
   NS_TEST_ASSERT_MSG_EQ (srcMeas.measId, dstMeas.measId, "Different measId!");
-  NS_TEST_ASSERT_MSG_EQ (srcMeas.rsrpResult, dstMeas.rsrpResult, "Different rsrpResult!");
-  NS_TEST_ASSERT_MSG_EQ (srcMeas.rsrqResult, dstMeas.rsrqResult, "Different rsrqResult!");
+  NS_TEST_ASSERT_MSG_EQ (srcMeas.measResultPCell.rsrpResult, dstMeas.measResultPCell.rsrpResult, "Different rsrpResult!");
+  NS_TEST_ASSERT_MSG_EQ (srcMeas.measResultPCell.rsrqResult, dstMeas.measResultPCell.rsrqResult, "Different rsrqResult!");
   NS_TEST_ASSERT_MSG_EQ (srcMeas.haveMeasResultNeighCells, dstMeas.haveMeasResultNeighCells, "Different haveMeasResultNeighCells!");
 
   if (srcMeas.haveMeasResultNeighCells)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/test-lte-epc-e2e-data.cc ns-3.36/src/lte/test/test-lte-epc-e2e-data.cc
--- ns-3.35/src/lte/test/test-lte-epc-e2e-data.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/test-lte-epc-e2e-data.cc	2022-04-30 18:23:58.062734600 -0700
@@ -373,8 +373,7 @@
 
 
 /**
- * \ingroup lte-test
- * \ingroup tests
+ * \ingroup tests lte-test
  *
  * \brief Test that the S1-U interface implementation works correctly
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/test-lte-handover-delay.cc ns-3.36/src/lte/test/test-lte-handover-delay.cc
--- ns-3.35/src/lte/test/test-lte-handover-delay.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/test-lte-handover-delay.cc	2022-04-30 18:23:58.062734600 -0700
@@ -50,8 +50,7 @@
 NS_LOG_COMPONENT_DEFINE ("LteHandoverDelayTest");
 
 /**
- * \ingroup lte-test
- * \ingroup tests
+ * \ingroup tests lte-test
  *
  * \brief Verifying that the time needed for handover is under a
  * specified threshold.
@@ -295,6 +294,12 @@
         AddTestCase (
           new LteHandoverDelayTestCase (1, true, handoverTime, Seconds (0.005),
                                         Seconds (0.200)), TestCase::QUICK);
+        AddTestCase (
+          new LteHandoverDelayTestCase (2, true, handoverTime, Seconds (0.005),
+                                        Seconds (0.200)), TestCase::QUICK);
+        AddTestCase (
+          new LteHandoverDelayTestCase (4, true, handoverTime, Seconds (0.005),
+                                        Seconds (0.200)), TestCase::QUICK);
       }
 
     // HANDOVER DELAY TEST CASES WITH REAL RRC (THRESHOLD = 0.020 sec)
@@ -306,6 +311,12 @@
         AddTestCase (
           new LteHandoverDelayTestCase (1, false, handoverTime, Seconds (0.020),
                                         Seconds (0.200)), TestCase::QUICK);
+        AddTestCase (
+          new LteHandoverDelayTestCase (2, false, handoverTime, Seconds (0.020),
+                                        Seconds (0.200)), TestCase::QUICK);
+        AddTestCase (
+          new LteHandoverDelayTestCase (4, false, handoverTime, Seconds (0.020),
+                                        Seconds (0.200)), TestCase::QUICK);
       }
   }
 } g_lteHandoverDelayTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/test-lte-x2-handover.cc ns-3.36/src/lte/test/test-lte-x2-handover.cc
--- ns-3.35/src/lte/test/test-lte-x2-handover.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/test-lte-x2-handover.cc	2022-04-30 18:23:58.062734600 -0700
@@ -332,7 +332,7 @@
 
               ApplicationContainer clientApps;
               ApplicationContainer serverApps;
-              BearerData bearerData;
+              BearerData bearerData = BearerData ();
 
               // always true: if (epcDl)
               {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/test-lte-x2-handover-measures.cc ns-3.36/src/lte/test/test-lte-x2-handover-measures.cc
--- ns-3.35/src/lte/test/test-lte-x2-handover-measures.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/test-lte-x2-handover-measures.cc	2022-04-30 18:23:58.062734600 -0700
@@ -412,7 +412,7 @@
 
               ApplicationContainer clientApps;
               ApplicationContainer serverApps;
-              BearerData bearerData;
+              BearerData bearerData = BearerData ();
 
               if (m_useUdp)
                 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/bindings/callbacks_list.py ns-3.36/src/mesh/bindings/callbacks_list.py
--- ns-3.35/src/mesh/bindings/callbacks_list.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/bindings/callbacks_list.py	2022-04-30 18:23:58.062734600 -0700
@@ -6,31 +6,24 @@
     ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'const ns3::Address &', 'ns3::NetDevice::PacketType', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'bool', 'ns3::Ptr<ns3::Packet>', 'ns3::Mac48Address', 'ns3::Mac48Address', 'unsigned short', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['std::vector<ns3::Mac48Address, std::allocator<ns3::Mac48Address>>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::dot11s::RouteChange', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned int', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::dot11s::PeerLink::PeerState', 'ns3::dot11s::PeerLink::PeerState', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Mac48Address', 'ns3::Mac48Address', 'unsigned int', 'bool', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['unsigned long', 'unsigned short', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned long', 'const ns3::WifiTxVector &', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['bool', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['bool', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Mac48Address', 'unsigned char', 'bool', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Mac48Address', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Time', 'ns3::Mac48Address', 'unsigned char', 'ns3::OriginatorBlockAckAgreement::State', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::WifiMacDropReason', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'unsigned int', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Time', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'const ns3::WifiMacHeader &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::WifiMacDropReason', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned char', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned char', 'ns3::Ptr<const ns3::WifiPsdu>', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'unsigned char', 'std::unordered_map<unsigned short, ns3::Ptr<ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<ns3::WifiPsdu> > > > *', 'const std::set<ns3::Mac48Address, std::less<ns3::Mac48Address>, std::allocator<ns3::Mac48Address> > *', 'unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'std::unordered_map<unsigned short, ns3::Ptr<ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<ns3::WifiPsdu>>>> *', 'const std::set<ns3::Mac48Address, std::less<ns3::Mac48Address>, std::allocator<ns3::Mac48Address>> *', 'unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned int', 'ns3::Mac48Address', 'ns3::Ptr<ns3::MeshWifiInterfaceMac>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['std::vector<ns3::Mac48Address, std::allocator<ns3::Mac48Address> >', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::dot11s::RouteChange', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'unsigned int', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::dot11s::PeerLink::PeerState', 'ns3::dot11s::PeerLink::PeerState', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Mac48Address', 'ns3::Mac48Address', 'unsigned int', 'bool', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
 ]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/CMakeLists.txt ns-3.36/src/mesh/CMakeLists.txt
--- ns-3.35/src/mesh/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/mesh/CMakeLists.txt	2022-04-30 18:23:58.062734600 -0700
@@ -0,0 +1,84 @@
+build_lib(
+  LIBNAME mesh
+  SOURCE_FILES
+    helper/dot11s/dot11s-installer.cc
+    helper/flame/flame-installer.cc
+    helper/mesh-helper.cc
+    helper/mesh-stack-installer.cc
+    model/dot11s/airtime-metric.cc
+    model/dot11s/dot11s-mac-header.cc
+    model/dot11s/hwmp-protocol-mac.cc
+    model/dot11s/hwmp-protocol.cc
+    model/dot11s/hwmp-rtable.cc
+    model/dot11s/hwmp-tag.cc
+    model/dot11s/ie-dot11s-beacon-timing.cc
+    model/dot11s/ie-dot11s-configuration.cc
+    model/dot11s/ie-dot11s-id.cc
+    model/dot11s/ie-dot11s-metric-report.cc
+    model/dot11s/ie-dot11s-peer-management.cc
+    model/dot11s/ie-dot11s-peering-protocol.cc
+    model/dot11s/ie-dot11s-perr.cc
+    model/dot11s/ie-dot11s-prep.cc
+    model/dot11s/ie-dot11s-preq.cc
+    model/dot11s/ie-dot11s-rann.cc
+    model/dot11s/peer-link-frame.cc
+    model/dot11s/peer-link.cc
+    model/dot11s/peer-management-protocol-mac.cc
+    model/dot11s/peer-management-protocol.cc
+    model/flame/flame-header.cc
+    model/flame/flame-protocol-mac.cc
+    model/flame/flame-protocol.cc
+    model/flame/flame-rtable.cc
+    model/mesh-information-element-vector.cc
+    model/mesh-l2-routing-protocol.cc
+    model/mesh-point-device.cc
+    model/mesh-wifi-beacon.cc
+    model/mesh-wifi-interface-mac.cc
+  HEADER_FILES
+    helper/dot11s/dot11s-installer.h
+    helper/flame/flame-installer.h
+    helper/mesh-helper.h
+    helper/mesh-stack-installer.h
+    model/dot11s/dot11s-mac-header.h
+    model/dot11s/hwmp-protocol.h
+    model/dot11s/hwmp-rtable.h
+    model/dot11s/ie-dot11s-beacon-timing.h
+    model/dot11s/ie-dot11s-configuration.h
+    model/dot11s/ie-dot11s-id.h
+    model/dot11s/ie-dot11s-metric-report.h
+    model/dot11s/ie-dot11s-peer-management.h
+    model/dot11s/ie-dot11s-peering-protocol.h
+    model/dot11s/ie-dot11s-perr.h
+    model/dot11s/ie-dot11s-prep.h
+    model/dot11s/ie-dot11s-preq.h
+    model/dot11s/ie-dot11s-rann.h
+    model/dot11s/peer-link-frame.h
+    model/dot11s/peer-link.h
+    model/dot11s/peer-management-protocol.h
+    model/flame/flame-header.h
+    model/flame/flame-protocol-mac.h
+    model/flame/flame-protocol.h
+    model/flame/flame-rtable.h
+    model/mesh-information-element-vector.h
+    model/mesh-l2-routing-protocol.h
+    model/mesh-point-device.h
+    model/mesh-wifi-beacon.h
+    model/mesh-wifi-interface-mac-plugin.h
+    model/mesh-wifi-interface-mac.h
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libwifi}
+    ${libapplications}
+  TEST_SOURCES
+    test/dot11s/dot11s-test-suite.cc
+    test/dot11s/hwmp-proactive-regression.cc
+    test/dot11s/hwmp-reactive-regression.cc
+    test/dot11s/hwmp-simplest-regression.cc
+    test/dot11s/hwmp-target-flags-regression.cc
+    test/dot11s/pmp-regression.cc
+    test/dot11s/regression.cc
+    test/flame/flame-regression.cc
+    test/flame/flame-test-suite.cc
+    test/flame/regression.cc
+    test/mesh-information-element-vector-test-suite.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/doc/source/conf.py ns-3.36/src/mesh/doc/source/conf.py
--- ns-3.35/src/mesh/doc/source/conf.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/doc/source/conf.py	2022-04-30 18:23:58.066734600 -0700
@@ -25,7 +25,7 @@
 
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.pngmath']
+extensions = ['sphinx.ext.imgmath']
 
 # Add any paths that contain templates here, relative to this directory.
 templates_path = ['_templates']
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/examples/CMakeLists.txt ns-3.36/src/mesh/examples/CMakeLists.txt
--- ns-3.35/src/mesh/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/mesh/examples/CMakeLists.txt	2022-04-30 18:23:58.066734600 -0700
@@ -0,0 +1,10 @@
+build_lib_example(
+  NAME mesh
+  SOURCE_FILES mesh.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libmobility}
+    ${libwifi}
+    ${libmesh}
+    ${libapplications}
+)
